<?php
/*
Plugin Name: Media in response
Plugin URI: http://djz.hu/
Description: Media in respond
Author: Zsolt Lakatos
Version: 0.1
Author URI: http://djz.hu/
*/
if(!defined('ABSPATH'))
{
  require('../../../wp-config.php');
} 

if ( !defined('WP_CONTENT_URL') ) define( 'WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
if ( !defined('WP_CONTENT_DIR') ) define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
//
// pre WP 2.6 compatibility
//
global $wpdb;

define('MIR_URL', WP_CONTENT_URL.'/plugins/media-in-response/media-in-response.php');

define('MIR_PICTURE_DIR', WP_CONTENT_DIR.'/mir-pictures');
define('MIR_VIDEO_DIR', WP_CONTENT_DIR.'/mir-videos');

define('MIR_PICTURE_TEMP', MIR_PICTURE_DIR.'/temp');
define('MIR_VIDEO_TEMP', MIR_VIDEO_DIR.'/temp');

define('MIR_PICTURE_URL_DIR', WP_CONTENT_URL.'/mir-pictures');
define('MIR_VIDEO_URL_DIR', WP_CONTENT_URL . '/mir-videos');

define('MIR_PICTURE_URL_TEMP', MIR_PICTURE_URL_DIR . '/temp');
define('MIR_VIDEO_URL_TEMP', MIR_VIDEO_URL_DIR . '/temp');

define('MIR_PICTURE_MAXDIMENSION','450');

define('MIR_VIDEO_TABLE',$wpdb->prefix.'videos');
define('MIR_PICTURE_TABLE',$wpdb->prefix.'post_pictures');

define('MIR_DEBUG','0');
define('MIR_LOG_FILE', WP_CONTENT_DIR.'/script.log');

$wpdb->mir_videos = MIR_VIDEO_TABLE;
$wpdb->mir_videos = MIR_PICTURE_TABLE;

/**
 * Handling file upload
 */ 
if (!empty($_FILES))
{ 
  if(!empty($_FILES['mir-picture']))
  { 
    mir_upload_picture();
  }
  elseif ($_FILES['mir-video'])
  {
    mir_upload_video();
  } 
}

/**
 * AJAX functions
 */ 
if(strstr($_SERVER['PHP_SELF'], "media-in-response.php"))
{
  if (isset($_GET['js'])) { mir_get_js(); }
  elseif (!empty($_POST['comment'])) mir_get_form_comment();
  elseif (!empty($_GET['form']) && ($_GET['form'] == 'common')) mir_get_form_common();
  elseif (!empty($_GET['form']) && ($_GET['form'] == 'buttons')) mir_get_form_buttons();
}

function mir_generate_thumbnail($filename, $thumbnail)
{
    $movie = new ffmpeg_movie($filename);
    $frameNum = $movie->getFrameCount();
    $frameNum=($frameNum/2);
    
    $frame = $movie->getFrame($frameNum);
    
    if ($frame)
    {
      //$width = $movie->getWidth();
      //$height = $movie->getHeight();
  
      //error_log( "[".date("Y-m-d H:i:s")."] filename: ".$filename."\n", 3, MIR_LOG);
      //error_log( "[".date("Y-m-d H:i:s")."] thumb: ".$thumbnail."\n", 3, MIR_LOG);
      //error_log( "[".date("Y-m-d H:i:s")."] movie: ".serialize($movie)."\n", 3, MIR_LOG);
      //error_log( "[".date("Y-m-d H:i:s")."] FrameNum: ".$frameNum."\n", 3, MIR_LOG);
         
      $capturedFrame = $frame->toGDImage();
  
      //error_log( "[".date("Y-m-d H:i:s")."] kep: ".$kep."\n", 3, MIR_LOG);
      
      return imagejpeg($capturedFrame, $thumbnail);
    }
    else
    {
      return false;
    }
}

function mir_resize_image($filename, $newFilename, $maxdimension, &$error)
{
	require_once('ImageResizer.inc.php');
	$resizer = new ImageResizer();
	$result = $resizer->openImageFile($filename);
	if ($result === false) $error = sprintf(__('File does not exists: %s'), $filename);
	$resizer->setDimensions($maxdimension, $maxdimension);
	$resizer->resizeNormal();
	switch ($resizer->getOriginalType()) 
  {
		case 'GIF':
			$resizer->outputGIF($newFilename);
		break;

		case 'JPEG':
			$resizer->outputJPEG($newFilename, 80);
		break;

		case 'PNG':
			$resizer->outputPNG($newFilename);
		break;
	}
}

function mir_get_js()
{
	header("Content-type: text/javascript"); 
?>

var mir_orig_action = '';
var mir_url = '<?php echo MIR_URL ?>';
var mir_site_url = '<?php echo get_option('siteurl'); ?>';
var mir_content_url = '<?php echo WP_CONTENT_URL; ?>';
var mir_swiff_url = '<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/swf/Swiff.Uploader.swf';

window.addEvent('domready', function() {
	mir_init();
});
<?php
	die;
}

function mir_get_form_common()
{
header("Content-Type: text/html");
?>
	<div id="mir_information">
		<h2><?php _e('To add media to your comment please click the button below, to see the available types'); ?></h2>
		<p class="small"><?php _e('You can upload picture type: JPG, GIF, PNG with the maximum file size of 2 MByte.'); ?></p>
		<p class="small"><?php _e('You can upload movie type: AVI, MPG, MP4, MOV, 3GP with the maximum file size of 10 MByte.'); ?></p>
	</div>


	<div id="mir_buttons" style="margin:10px 0;">
		<input type="button" id="mir_select_type" value="<?php _e('I want to add media to my response!'); ?>">
	</div>
<?php
die;
}

function mir_get_form_buttons()
{
header("Content-type: text/plain");
?>
  <div id="mir-picture-message" class="hide">The image has been uploaded</div><br/>
  <div id="mir-video-message" class="hide">The video has been uploaded</div><br/>
  <input type="button" id="mir_upload_picture" value="Upload Image">
  <input type="button" id="mir_upload_video" value="Upload Video"><br/>
  <?php /* <img src="/de/blog/wp-content/themes/zottarella/images/submit_bild.png" id="mir_upload_picture" value="Bild"/><img src="/de/blog/wp-content/themes/zottarella/images/submit_video.png" id="mir_upload_video" value="Video"/><br/> */ ?>
  
  <div id="mir-picture" class="hide">	 
  	<div id="mir-picture-status" class="hide">
  		<div>
  			<img src="/de/blog/wp-content/plugins/media-in-response/images/loading.gif" class="progress current-progress" />
  		</div>
  		<div class="current-text"></div>
  	</div>
  	<input id="mir-picture-file" name="comment_picture" type="hidden" value=""/>
  	
	 <div id="mir-confirmation" style="display:none;">Dieses Bild bzw. Video wird beim Absenden in den Kommentar eingefügt:</div>
  	<div id="mir-picture-preview">
  	 <img id="mir-picture-image" src="/de/blog/wp-content/plugins/media-in-response/images/picture_default.jpg" alt="">
  	</div>
  	<div id="mir-picture-options">
  	<?php /*>
  	 <a href="#mir" id="mir-picture-delete" class="hide"><!--Bild entfernen--></a>
  	 <a href="#mir" id="mir-picture-other" class="hide"><!--Anderes Bild hochladen--></a>
  	 <!-- input type="button" id="mir-picture-insert" value="&nbsp;" / -->
	   <img src="/de/blog/wp-content/themes/zottarella/images/submit_insert.png" alt="Bild in den Kommentar einfügen" id="mir-picture-insert"/>
	   */ ?>
  	</div>
  	<span id="mir"></span>
  </div>  

  <div id="mir-video" class="hide">
    <p><?php _e('The video upload progress may take a while, please be patient'); ?></p><br/>	 
  	<div id="mir-video-status" class="hide">
  		<div>
  			<img src="/de/blog/wp-content/plugins/media-in-response/images/loading.gif" class="progress current-progress" />
  		</div>
  	</div>
  	<input id="mir-video-file" type="hidden" name="comment_video" value=""/>
  	
  	<div id="mir-video-preview">
  	 <img id="mir-video-image" src="/de/blog/wp-content/plugins/media-in-response/images/video_default.jpg" alt="">
  	</div>
  	<div id="mir-video-options">
	 <?php /*
  	 <a href="#" id="mir-video-delete" class="hide"><!--Bild entfernen--></a><br/>
  	 <a href="#" id="mir-video-other" class="hide"><!--Anderes Bild hochladen--></a><br/>
  	 <!-- input type="button" id="mir-video-insert" value="&nbsp;" / -->
     <img src="/de/blog/wp-content/themes/zottarella/images/submit_insert_video.png" id="mir-video-insert"  alt="Video in den Kommentar einfügen"/> 
     */ ?>
  	</div>
  </div>
  
<?php
die;
}

function mir_upload_video()
{
	$file = $_FILES['mir-video']['tmp_name'];
	$orig_name = strtolower($_FILES['mir-video']['name']);
	$error = false;
	$size = false;
 
	if ($_FILES['mir-video']['error'] == 1)
	{
    $error = sprintf(__('Please upload only files smaller than %s.'), ini_get('upload_max_filesize'));
	}
 
   /*if (MIR_DEBUG > 0)
   {
	   $addr = gethostbyaddr($_SERVER['REMOTE_ADDR']);     
	   $log = fopen('script.log', 'a');
	   fputs($log, "[".date("Y-m-d H:i:s")."] ".($error ? 'FAILED' : 'SUCCESS') . ' - ' . $addr . ": {$_FILES['mir-video']['name']} - {$_FILES['mir-video']['size']} byte\n" );
	   
	   fputs($log, serialize($_FILES)."\n"  );
  }*/

	if ($error)
	{
		$result['result'] = 'failed';
		$result['error'] = $error;
	}
	else
	{
		$result['result'] = 'success';
		
		$pos = strrpos($orig_name,'.');
		$ext = substr($orig_name,$pos+1,strlen($orig_name)-$pos);
		$result['ext'] = $ext;
		$result['size'] = "Uploaded a video";
		$hash = substr(md5(time()),10,6);
		$newFilename = $hash.".".$ext;

    //var_dump(DIRECTORY_SEPARATOR);
		
		//$target = MYVIDEO_TEMP.'/'.$hash[0].'/'.$hash[1].'/'.$newFilename;
    $target = MIR_VIDEO_TEMP.'/'.$newFilename;
		$ret = move_uploaded_file($file,$target);
		
		$src = '';
		
		if ($ret)
		{
		  $thumbnail = '/thumb/'.$hash.'.jpg';
		
		  if (class_exists('ffmpeg_movie'))
		  {
		    mir_generate_thumbnail($target,MIR_VIDEO_TEMP.$thumbnail);
		    
		    if(is_file(MIR_VIDEO_TEMP.'/'.$thumbnail))
		    {
          $src = MIR_VIDEO_URL_TEMP.$thumbnail;
        }
        else
        {
          /*if (MIR_DEBUG > 0)
          {
    		    error_log( "[".date("Y-m-d H:i:s")."] THUMBNAIL GENERATION ERROR!\n", 3, MIR_LOG);
    		  }*/            
        }
		  }
		  else
		  {
       /*if (MIR_DEBUG > 0)
       {       	
  		  fputs($log, "[".date("Y-m-d H:i:s")."] NO FFMPEG!\n" );
  		  }*/           
      }
    }
		  
         
	 $result['filename'] = $newFilename;
	 $result['src'] = $src; //XXX

   /*if (MIR_DEBUG > 0)
   {
   
      error_log( "[".date("Y-m-d H:i:s")."] RESULT ".serialize($ret)."\n", 3, MIR_LOG);
                   
      error_log( "[".date("Y-m-d H:i:s")."] MOVE ".($ret ? 'SUCCESS' : 'FAILED')." ".$newFilename."\n", 3, MIR_LOG);
	  }*/    	 
	 
	 //$result['src'] = MIR_PICTURE_URL_TEMP.'/'.$newFilename;
   //nosnapshot :\              
  }
  
  if (!headers_sent() )
  {
  	header('Content-type: application/json');
  }
  
  echo json_encode($result);
  die;
}

function mir_upload_picture()
{
	$file = $_FILES['mir-picture']['tmp_name'];
	$error = false;
	$size = false;
 
	if ($_FILES['mir-picture']['error'] == 1)
	{
		$error = sprintf(__('Please upload only files smaller than %s.'), ini_get('upload_max_filesize'));
	}
	
	if (empty($error) && !($size = @getimagesize($file) ) )
	{
		$error = __('Please upload only images, no other files are supported.');
	}
	if (empty($error) && !in_array($size[2], array(1, 2, 3, 7, 8) ) )
	{
		$error = __('Please upload only supported type images.');
	}
	if (empty($error) && (($size[0] < 25) || ($size[1] < 25)))
	{
	   $error = sprintf(__('Please upload an image bigger than %s.'), "25px");
	}
	
	$addr = gethostbyaddr($_SERVER['REMOTE_ADDR']);
 
/*      if (MIR_DEBUG > 0)
  {   
    error_log("[".date("Y-m-d H:i:s")."] ".($error ? 'FAILED' : 'SUCCESS') . ' - ' . $addr . ": {$_FILES['mir-picture']['name']} - {$_FILES['mir-picture']['size']} byte\n", 3, MIR_LOG);
    
    error_log(serialize($_FILES)."\n", 3, MIR_LOG);
  }*/
  
	if ($error)
	{
		$result['result'] = 'failed';
		$result['error'] = $error;
	}
	else
	{
		$result['result'] = 'success';
		
		$mime = $size['mime'];
		$pos = strpos($mime,'/');
		$ext = substr($mime,$pos+1,strlen($mime)-$pos);
		$result['ext'] = $ext;
		if ($ext == 'jpeg') $ext = 'jpg';
		
		$result['size'] = sprintf(__('Uploaded an image %s with %d px / %d px.'), array("({$size['mime']})","{$size[0]}","{$size[1]}"));
		
		$hash = substr(md5(time()),10,6);
		$newFilename = $hash.".".$ext;

	  $ret = move_uploaded_file($file,MIR_PICTURE_TEMP.'/'.$newFilename);
		
		if($ret)
		{
		  $result['filename'] = $newFilename;
		  $result['src'] = MIR_PICTURE_URL_TEMP.'/'.$newFilename;
    }
	
     /*if (MIR_DEBUG > 0)
     {          
      error_log("[".date("Y-m-d H:i:s")."] RESULT ".serialize($ret)."\n", 3, MIR_LOG);          
      error_log("[".date("Y-m-d H:i:s")."] MOVE ".($ret ? 'SUCCESS' : 'FAILED')." ".$newFilename."\n", 3, MIR_LOG);
		  }*/
	}
	
	/*if (MIR_DEBUG > 0)
	{
    error_log("[".date("Y-m-d H:i:s")."] $file -> ".MIR_PICTURE_TEMP.'/'.$newFilename."\n", 3, MIR_LOG);    	 

    error_log( "[".date("Y-m-d H:i:s")."] RESULT ".serialize($result)."\n", 3, MIR_LOG);
    
	}*/
	
  if (!headers_sent() )
  {
  	header('Content-type: application/json');
  }
  
  echo json_encode($result);
  die;
}

function mir_get_form_comment()
{
  function fail($s) { header('HTTP/1.0 406 Not Acceptable'); die($s); }

  foreach($_POST as $k => $v) $_POST[$k] = trim(urldecode($v));

  // extract & alias POST variables
   extract($_POST, EXTR_PREFIX_ALL, '');

  // get the post comment_status
  $post_status = $wpdb->get_var("SELECT comment_status FROM {$wpdb->posts} WHERE ID = '".$wpdb->escape($_comment_post_ID)."' LIMIT 1;");
  if ( empty($post_status) ) // make sure the post exists
    fail(__("That post doesn't even exist!"));
  if ( $post_status == 'closed' ) // and the post is not closed for comments
    fail(__("Sorry, comments are closed."));

  // if the user is already logged in
  get_currentuserinfo();
  
  if ( $user_ID )
  {
    $_author = addslashes($user_identity); // get their name
    $_email = addslashes($user_email); // email
    $_url = addslashes($user_url); // and url
  }

  if ( $_comment == '' ) fail(__('Please fill in the comment field.'));

  // Simple duplicate check
  if($wpdb->get_var("
  SELECT comment_ID FROM {$wpdb->comments}
  WHERE comment_post_ID = '".$wpdb->escape($_comment_post_ID)."'
    AND ( comment_author = '".$wpdb->escape($_author)."'
  ".($_email? " OR comment_author_email = '".$wpdb->escape($_email)."'" : "")."
  ) AND comment_content = '".$wpdb->escape($_comment)."'
  LIMIT 1;"))
    fail(__('You already said that before.'));

  // insert comment into WordPress database
  $comment_ID = wp_new_comment(array(
    'comment_post_ID' => $_comment_post_ID,
    'comment_author' => $_author,
    'comment_author_email' => $_email,
    'comment_author_url' => $_url,
    'comment_content' => $_comment,
    'comment_type' => '',
    'user_ID' => $user_ID
  ));

  // if the user is not already logged in and wants to be Remembered
  if ( !$user_ID && isset($_remember) ) { // remember cookie
    setcookie('comment_author_' . COOKIEHASH, $_author, time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
    setcookie('comment_author_email_' . COOKIEHASH, $_email, time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
    setcookie('comment_author_url_' . COOKIEHASH, $_url, time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
  } else { // forget cookie
    setcookie('comment_author_' . COOKIEHASH, '', time() - 30000000, COOKIEPATH, COOKIE_DOMAIN);
    setcookie('comment_author_email_' . COOKIEHASH, '', time() - 30000000, COOKIEPATH, COOKIE_DOMAIN);
    setcookie('comment_author_url_' . COOKIEHASH, '', time() - 30000000, COOKIEPATH, COOKIE_DOMAIN);
  }
  
  $picture_pattern = "/^([a-f0-9]{6})\.(jpg|gif|png)/i";
  $video_pattern = "/^([a-f0-9]{6})\.(wmv|mov|avi|3gp|mpg)/i";
  
  if (!empty($_POST['comment_picture']) && preg_match($picture_pattern,$_POST['comment_picture']))
  {
    $mir_image = $_POST['comment_picture'];
    
    $pos = strrpos($mir_image,'.');
    $hash = substr($mir_image,0,$pos);
    $ext = substr($mir_image,$pos+1,3);
    //
    // 3 characters, because we did the jpeg->jpg type conversion before
    //

 		$newSmallFilename = 'thumbnail.' . $hash . '.' . $ext;
 		
 		rename(MIR_PICTURE_TEMP.'/'.$mir_image,MIR_PICTURE_DIR.'/'.$mir_image);
 		mir_resize_image(MIR_PICTURE_DIR.'/'.$mir_image, MIR_PICTURE_DIR.'/'.$newSmallFilename, MIR_PICTURE_MAXDIMENSION, &$error);
  
    $data = array('picture_filename'=>$mir_image,'picture_owner'=>$user_ID,'picture_attached'=>$comment_ID,'picture_public'=>'1','picture_created'=>date('Y-m-d H:i:s'));
    $ret = $wpdb->insert(MIR_PICTURE_TABLE,$data);
  }
  if (!empty($_POST['comment_video']) && preg_match($video_pattern,$_POST['comment_video']))
  {
    $mir_video = $_POST['comment_video'];
    
    $pos = strrpos($mir_video,'.');
    $hash = substr($mir_video,0,$pos);
    $ext = substr($mir_video,$pos+1,3);
  
    $thumb = '/thumb/'.$hash.'.jpg';
  
    $ret = @rename(MIR_VIDEO_TEMP.'/'.$mir_video,MIR_VIDEO_DIR.'/'.$mir_video);
  
//    var_dump($mir_video);
//    var_dump($ret);
  
    if($ret)
    {
      @rename(MIR_VIDEO_TEMP.'/'.$thumb,MIR_VIDEO_DIR.'/'.$thumb);
      $data = array('video_hash'=>$hash,'video_filename'=>$mir_video,'video_owner'=>$user_ID,'video_attached'=>$comment_ID,'video_type'=>'comment','video_public'=>'1','video_created'=>date('Y-m-d H:i:s'));
      
      if (MIR_DEBUG > 0)
      {   
        error_log("[".date("Y-m-d H:i:s")."] VIDEO_DATA: ".serialize($data), 3, MIR_LOG);
      }      
      
      $ret = $wpdb->insert(MIR_VIDEO_TABLE,$data);  
     }
  }
  die;
}

function mir_get_comment_media($comment_ID) {
  global $wpdb;

//  var_dump($comment_ID);
  
  //var_dump($wpdb);
  
//print "SELECT * FROM ".MIR_VIDEO_TABLE." WHERE video_attached = '".$comment_ID."' AND video_type = 'comment' AND video_public = '1' AND video_processed = '1'";
  $videoSearch = $wpdb->get_results("SELECT * FROM ".MIR_VIDEO_TABLE." WHERE video_attached = '".$comment_ID."' AND video_type = 'comment' AND video_public = '1' AND video_processed = '1'");
  
  if ($videoSearch)
  {
    $video = MIR_VIDEO_URL_DIR."/".$videoSearch[0]->video_filename;
    ?>
      <embed src="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/swf/player.swf" width="400" height="320" allowscriptaccess="always" allowfullscreen="true" flashvars="height=320&width=400&file=<?php echo $video; ?>&backcolor=0xCAD5DC&frontcolor=0x535353&lightcolor=0x000000&showdigits=false&usefullscreen=false&thumbsinplaylist=false" />
    <?php
  }

  $pictureSearch = $wpdb->get_results("SELECT * FROM ".MIR_PICTURE_TABLE." WHERE picture_attached = '".$comment_ID."' AND picture_public = '1'");

  if ($pictureSearch)
  {
    $picture = $pictureSearch[0];
    
    $rows = $picture%3;
    
    ?>
    <dl class="gallery-item">
      <dt class="gallery-icon">
        <a title="" href="">
          <img class="attachment-thumbnail" src="<?php echo MIR_PICTURE_URL_DIR.'/thumbnail.'.$picture->picture_filename; ?>">
        </a>
      </dt>
    </dl>
    <br style="clear: both;"/>
    <?php
    //echo '<span class="mir_picture"><img src="'.MIR_PICTURE_URL_DIR.'/'.$picture->picture_filename.'" width="430" height="350"></span>';

  }
}

function media_in_respond_head()
{
?>
<link href="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/css/mir.css" type="text/css" rel="stylesheet"/>
<script type="text/javascript" src="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/js/mootools.js"></script>
<script type="text/javascript" src="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/js/mir_core.js"></script>
<script type="text/javascript" src="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/js/Swiff.Uploader.js"></script>
<script type="text/javascript" src="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/js/Fx.ProgressBar.js"></script>
<script type="text/javascript" src="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/js/FancyUpload2.js"></script>
<script type="text/javascript" src="<?php echo WP_CONTENT_URL; ?>/plugins/media-in-response/media-in-response.php?js"></script>
<?php
}

add_action('wp_head','media_in_respond_head');

?>